]> git.pld-linux.org Git - packages/rpm.git/blob - rpm.macros
- pass FCFLAGS (for Fortran >77)
[packages/rpm.git] / rpm.macros
1 # $Revision$, $Date$
2 # PLD Linux rpm macros
3
4 %epoch          0
5 %x8664          x86_64 amd64 ia32e
6
7 # kernel compiler
8 %kgcc           %{__cc}
9 %kgcc_package   gcc
10
11 # Build system path macros.
12 #
13 %__autoconf             autoconf %{?debug:-Wall}
14 %__automake             automake -a -c -f --foreign
15 %__autopoint            autopoint --force
16
17 %__gettextize { \
18 if ! gettextize --version | grep -q '0\.10\.' ; then \
19         if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
20                 gettextize --copy --force --no-changelog; \
21         else \
22                 gettextize --copy --force --no-changelog --intl; \
23         fi; \
24         if [ ! -f po/Makevars ]; then \
25                 cp -f po/Makevars{.template,}; \
26         fi; \
27 else \
28         gettextize --copy --force; \
29 fi; \
30 }
31
32 %__glib_gettextize      glib-gettextize --copy --force
33 %__gnome_doc_common     gnome-doc-common --copy
34 %__gnome_doc_prepare    gnome-doc-prepare --copy --force
35 %__gtkdocize            gtkdocize --copy
36 %__intltoolize          intltoolize --copy --force
37 %__libtoolize           libtoolize --copy --force
38
39 #       The number of cvs changelog entries kept when building package.
40 %_buildchangelogtruncate 20
41
42 %dependencytracking     %{nil}
43
44 #       Relations between package names that cause dependency loops
45 #       with legacy packages that cannot be fixed. Relations are
46 #       specified as
47 #               p>q
48 #       where package p has a Requires: on something that package q Provides:
49 #
50 # XXX   Note: that there cannot be any whitespace within the string "p>q",
51 #       and that both p and q are package names (i.e. no version/release).
52 %_dependency_whiteout   %{nil}
53
54
55 #-----------------------------------------------------------------
56 #
57 # (re)definition of %{rpm*flags} with %filterout_* support
58 # BuildRequires:        awk
59 # BuildRequires:        rpmbuild(macros) >= 1.315
60 #
61 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
62 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
63 # %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
64 # %rpmldflags   = %optldflags - %filterout_ld
65 #
66 # Regular expressions are supported, but to avoid some character be treated
67 # as regular expression it must be escaped twice.
68
69 %filter_out                                             \
70         for (i = 1; i in I; i++) {      A=0;    \
71                 for (f in F) {                          \
72                         if (I[i] ~ "^" F[f] "$") A=1;   \
73                 };                                                      \
74                 if (!A) printf(I[i] FS);        \
75         }
76
77 %rpmcflags %(awk 'BEGIN {
78         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
79         split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
80         %{filter_out}
81 }')
82
83 %rpmcxxflags %(awk 'BEGIN {
84         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
85         split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
86         %{filter_out}
87 }')
88
89 %rpmldflags %(awk 'BEGIN {
90         split("%{?optldflags}",I);
91         split("%{?filterout_ld}",F)
92         %{filter_out}
93 }')
94
95 # rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
96 # but, don't use it, better use gcc as linker
97 %ld_rpmldflags %(awk 'BEGIN {
98         split("%{rpmldflags}",F);
99         for (f in F) {
100                 s = F[f];
101                 if (s ~ /^-Wl,/) {
102                         s = substr(s,5);
103                         gsub(/,/," ",s);
104                 };
105                 printf(s FS);
106         };
107 }')
108
109 #-----------------------------------------------------------------
110 %configure2_13 { \
111  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
112  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
113  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
114  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
115  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
116  FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
117  CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
118  %{?__cc:CC="%{__cc}" ; export CC ; } \
119  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
120  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
121         --host=%{_target_platform} \
122         --prefix=%{_prefix} \
123         --exec-prefix=%{_exec_prefix} \
124         --bindir=%{_bindir} \
125         --sbindir=%{_sbindir} \
126         --sysconfdir=%{_sysconfdir} \
127         --datadir=%{_datadir} \
128         --includedir=%{_includedir} \
129         --libdir=%{_libdir} \
130         --libexecdir=%{_libexecdir} \
131         --localstatedir=%{_localstatedir} \
132         --sharedstatedir=%{_sharedstatedir} \
133         --mandir=%{_mandir} \
134         --infodir=%{_infodir} \
135         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
136         %{dependencytracking} \
137 }
138
139 # override __cmake to add -j4 in your ~/.rpmmacros for parallel make
140 %__cmake        /usr/bin/cmake
141 %cmake { \
142 CC="%{__cc}" \
143 CXX="%{__cxx}" \
144 CFLAGS="%{rpmcflags}" \
145 CXXFLAGS="%{rpmcxxflags}" \
146 %{__cmake} \
147 }
148
149 # override __scons to add -j4 in your ~/.rpmmacros for parallel make
150 # TODO: find way to pass CC/CXX and CC/CXXFLAGS
151 %__scons        /usr/bin/scons
152 %scons { \
153 %{__scons} \
154 }
155
156 # waf. see waf.spec
157 # override __waf to add -j4 in your ~/.rpmmacros for parallel make
158 %__waf  /usr/bin/waf
159 %waf { \
160 CC="%{__cc}" \
161 CXX="%{__cxx}" \
162 CPP="%{__cpp}" \
163 CFLAGS="%{rpmcflags}" \
164 CXXFLAGS="%{rpmcxxflags}" \
165 %{__waf} \
166 }
167
168 #----------------------------------------------------------------
169 %global configure_cache 0
170 %configure_cache_file   %{buildroot}.configure.cache
171
172 %configure {./configure \
173         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
174         CFLAGS="${CFLAGS:-%rpmcflags}" \
175         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
176         FFLAGS="${FFLAGS:-%rpmcflags}" \
177         FCFLAGS="${FCFLAGS:-%rpmcflags}" \
178         CPPFLAGS="${CPPFLAGS:-}" \
179         %{?__cc:CC="%{__cc}"} \
180         %{?__cxx:CXX="%{__cxx}"} \
181         --host=%{_target_platform} \
182         --build=%{_target_platform} \
183         --prefix=%{_prefix} \
184         --exec-prefix=%{_exec_prefix} \
185         --bindir=%{_bindir} \
186         --sbindir=%{_sbindir} \
187         --sysconfdir=%{_sysconfdir} \
188         --datadir=%{_datadir} \
189         --includedir=%{_includedir} \
190         --libdir=%{_libdir} \
191         --libexecdir=%{_libexecdir} \
192         --localstatedir=%{_localstatedir} \
193         --sharedstatedir=%{_sharedstatedir} \
194         --mandir=%{_mandir} \
195         --infodir=%{_infodir} \
196         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
197         %{dependencytracking} \
198         %{?configure_cache:--cache-file=%{configure_cache_file:-%{buildroot}.configure.cache}} \
199 }
200
201 # ------------------------------------------------------------------------
202 # Overloading of some basic macros
203 %prep \
204 %%prep\
205 export LC_ALL=C\
206 export LANG=C\
207 unset LINGUAS ||:\
208 unset LANGUAGE ||:\
209 unset LC_MESSAGES ||:\
210 unset DISPLAY ||:\
211 %{nil}
212
213 %build %%build\
214 export LC_ALL=C\
215 export LANG=C\
216 unset LINGUAS ||:\
217 unset LANGUAGE ||:\
218 unset LC_MESSAGES ||:\
219 unset DISPLAY ||:\
220 %{nil}
221
222 %install \
223 %if 0%{?_enable_debug_packages}\
224 %{?buildsubdir:%{debug_package}}\
225 %endif\
226 %%install\
227 export LC_ALL=C\
228 export LANG=C\
229 unset LINGUAS ||:\
230 unset LANGUAGE ||:\
231 unset LC_MESSAGES ||:\
232 unset DISPLAY ||:\
233 %{nil}
234
235 # Location of autoconf macros
236 %_aclocaldir    %(aclocal --print-ac-dir)
237
238 # Location of omf files
239 %_omf_dest_dir  %(scrollkeeper-config --omfdir)
240
241 # Location of pkgconfig files
242 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
243
244 # Location of desktop files
245 %_desktopdir    /usr/share/applications
246 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
247
248 # Location of pixmaps for applnk/desktop files
249 %_pixmapsdir    /usr/share/pixmaps
250
251 # Location of themable icons for applnk/desktop files
252 %_iconsdir      /usr/share/icons
253
254 # Location of fonts directories
255 %_fontsdir      /usr/share/fonts
256
257 # Location of Gtk and associated libraries documentation
258 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
259
260 # Location of KDE documentation
261 %_kdedocdir     %{_defaultdocdir}/kde/HTML
262
263 # unsermake script
264 %__unsermake /usr/share/unsermake/unsermake
265
266 # Current date
267 %date           %(LC_ALL="C" date +"%a %b %d %Y")
268
269 # tmp directory
270 %tmpdir         %(echo "${TMPDIR:-/tmp}")
271
272 # Example files, programs, scripts...
273 %_examplesdir   /usr/src/examples
274
275 # Alternative kernel type/version
276 %_alt_kernel    %{nil}%{?alt_kernel:-%{?alt_kernel}}
277
278 # The directory holding Linux kernel sources
279 %_kernelsrcdir  /usr/src/linux%{_alt_kernel}
280
281 # If non-empty "debug" macro defined, add "dbg" suffix to release number
282 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
283
284 # Requires name = version-release
285 %requires_releq()               %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}-%%{release}\\n' | sed -e 's/ (none):/ /' | grep -v "is not")
286
287 %releq_kernel()         %((LC_ALL="C" rpm -qf --qf '%%{name} = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
288 %requires_releq_kernel(s:)      Requires%{-s:(%{-s*})}: %releq_kernel
289
290 %requires_eq()          %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}\\n' | sed -e 's/ (none):/ /' -e 's/ 0:/ /' | grep -v "is not")
291 %requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %%{epoch}:%%{version}\\n' %2 | sed -e 's/ (none):/ /' | grep -v "is not")
292
293 %apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)
294
295 # kernel version-release handling
296 %__kernel_ver   %( VER_H=%{_kernelsrcdir}/include/linux/utsrelease.h; [ -f $VER_H ] || VER_H=%{_kernelsrcdir}/include/linux/version.h; [ -f $VER_H ] && (grep UTS_RELEASE $VER_H 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))
297 %__kernel_rel   %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{RELEASE}" | grep -v "is not")
298 %__kernel_rpmvr %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{VERSION}-%{RELEASE}" | grep -v "is not")
299 %_kernel_ver    %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}
300 %_kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')
301
302 # sgml macros
303 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
304 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
305 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
306 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
307 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
308 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
309 %docbook_sgmlcat_fix() { for l in \
310 '' \
311 '  -- default decl --' \
312 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
313 '  -- hacks for opensp --' \
314 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
315 'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd"                  "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
316 '' \
317 ; do echo $l; done >> %1 \
318 }
319
320 # vim - "
321
322 # minimum file size needed for compressed documents.
323 # just smaller files than this get larger when compressed.
324 # some stats:
325 # - 0 byte file compressed was 25 bytes .gz
326 # - 39 byte file was compressed as 57
327 # - with test/test.spec@man 158 byte file was compressed also 158
328 %_min_compress_bytes    159
329
330 #-----------------------------------------------------------------
331 # find and gzip all files in %{_mandir} and %{infodir}
332 #
333 # Requires: xargs, find
334 #
335 #%no_install_post_compress_docs 1
336 %__spec_install_post_compress_docs { \
337 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
338         for i in /usr/share/man /usr/X11R6/man /usr/share/info; do \
339                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
340                         echo "Compress $(basename $i) pages: $i"; \
341                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
342                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
343                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
344                 fi; \
345         done; \
346 }; __spec_install_post_compress_docs } }
347
348 #-----------------------------------------------------------------
349 # Strip executable binaries and shared object files
350 #
351 # Requires: find, awk, strip, cut, xargs
352 #
353 #%no_install_post_strip 1
354 %__spec_install_post_strip {%{!?debug: \
355 %{!?no_install_post_strip:__spec_install_post_strip() { \
356 if [ -d "$RPM_BUILD_ROOT" ]; then \
357         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
358                 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
359                 printf "Stripping %d kernel modules..." $(echo "$modulelist" | wc -l); \
360                 echo "$modulelist" | xargs -l512 chmod u+w; \
361                 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
362                 echo "DONE"; \
363         fi; \
364         filelist=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"}`; \
365         # vim - " \
366         if [ -z "$filelist" ]; then \
367                 return; \
368         fi; \
369         filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
370         elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
371         elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
372         archiveslist=`echo "$filetypes" | awk -F '/current ar archive/ {print $1}'`; \
373         if [ -n "$elfexelist" ]; then \
374                 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
375                 chmod u+w $elfexelist; \
376                 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
377                 echo "DONE"; \
378         fi; \
379         if [ -n "$elfsharedlist" ]; then \
380                 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
381                 chmod u+w $elfsharedlist; \
382                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
383                 echo "DONE"; \
384         fi; \
385         if [ -n "$archiveslist" ]; then \
386                 printf "Stripping %d ar archives..." $(echo "$elfsharedlist" | wc -l); \
387                 chmod u+w $archiveslist; \
388                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
389                 echo "DONE"; \
390         fi; \
391 fi; }; __spec_install_post_strip } } }
392
393 #-----------------------------------------------------------------
394 # remove all RPATH from executable binaries and shared object files
395 #
396 # Requires: find, awk, cut, xargs, chrpath, uname
397 #
398 #%no_install_post_chrpath       1
399 %__spec_install_post_chrpath {%{!?debug: \
400 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
401 if [ -d "$RPM_BUILD_ROOT" ]; then \
402         files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*"  %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
403         if [ -n "$files" ]; then \
404                 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
405         fi
406         #"
407         if [ -n "$objs" ]; then \
408                 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
409                 echo "$objs" | \
410                 while read file; do \
411                         rpath= ; \
412                         chmod u+w "$file"; \
413                         for dir in `chrpath -l "$file" | \
414                                         awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
415                                         case $dir in \
416                                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
417                                                 echo "remove-rpath: $dir in $file"; \
418                                                 ;; \
419                                         * ) \
420                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
421                                                 else rpath="$rpath:$dir" ; fi ; \
422                                                 ;; \
423                                         esac ; \
424                         done ; \
425                         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
426                         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
427                 done; \
428         fi; \
429 fi; }; __spec_install_post_chrpath } } }
430
431 #-----------------------------------------------------------------
432 # Find and gzip all kernel modules
433 #
434 # Requires: find
435 #
436 #%no_install_post_compress_modules      1
437 %__spec_install_post_compress_modules { \
438 %{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
439         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
440                 echo "Compress kernel modules"; \
441                 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
442                 echo "$q" | xargs -r %{__gzip} -9nf; \
443                 printf "%d modules compressed\n" $(echo "$q" | wc -l); \
444                 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
445                 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
446         fi; \
447 }; __spec_install_post_compress_modules } }
448
449 # Remove common Perl files we don't package
450 %__spec_install_post_perl_clean {\
451 %{!?no_install_post_perl_clean: \
452 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
453 } }
454
455 #-----------------------------------------------------------------
456 # Update GConf2 schemas
457 #
458 # Requires: GConf2
459 #
460 %gconf_schema_install() \
461         umask 022; \
462         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null \
463         %{nil}
464
465 %gconf_schema_uninstall() \
466 if [ $1 = 0 ]; then \
467         umask 022; \
468         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
469 fi \
470 %{nil}
471
472 #-----------------------------------------------------------------
473 # Update desktop MIME database
474 # requires: desktop-file-utils
475 #
476 %update_desktop_database_post() {{ \
477         umask 022; \
478         /usr/bin/update-desktop-database -q; \
479 }}
480
481 %update_desktop_database_postun() {{ \
482 if [ $1 = 0 ]; then \
483         umask 022; \
484         /usr/bin/update-desktop-database -q; \
485 fi \
486 }}
487
488 #-----------------------------------------------------------------
489 # Update shared MIME info database
490 # requires: shared-mime-info
491 #
492 %update_mime_database() {{ \
493         umask 022; \
494         /usr/bin/update-mime-database %{_datadir}/mime; \
495 }}
496
497 #-----------------------------------------------------------------
498 # Update icon cache
499 # requires: gtk+
500 #
501 %update_icon_cache() {{ \
502         umask 022; \
503         /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
504 }}
505
506 #-----------------------------------------------------------------
507 # Update scrollkeeper database
508 # requires: scrollkeeper
509 #
510 %scrollkeeper_update_post() \
511         /usr/bin/scrollkeeper-update -q; \
512         %{nil}
513
514 %scrollkeeper_update_postun() \
515 if [ $1 = 0 ]; then \
516         /usr/bin/scrollkeeper-update -q; \
517 fi \
518 %{nil}
519
520 #-----------------------------------------------------------------
521 # post %install sequence:
522 # - autodeps exceptions
523 # - compress all man and info pages,
524 # - strip all ELF executables and ELF shared objects if not %debug.
525 # - compress kernel modules if any
526
527 ###################################################################
528 # Requires/Provides automation
529 # exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
530 #
531 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
532 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
533 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
534 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
535 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
536 #%_noautocompressdoc    %{nil}
537 #
538 %_missing_doc_files_terminate_build     1%{nil}
539 %_unpackaged_files_terminate_build      %{nil}
540 # (X)emacs support
541 %___emacs_lispdir_helper  -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
542 %_emacs_lispdir %(emacs %___emacs_lispdir_helper)
543 %_xemacs_lispdir %(xemacs %___emacs_lispdir_helper)
544
545 %__php_provides %{nil}
546 %__php_requires %{nil}
547 %__perl_provides %{nil}
548 %__perl_requires %{nil}
549 %__mono_provides %{nil}
550 %__mono_requires %{nil}
551
552 # Perl specific macro definitions.
553 %perl_privlib           %(eval "`%{__perl} -V:installprivlib`"; echo $installprivlib)
554 %perl_archlib           %(eval "`%{__perl} -V:installarchlib`"; echo $installarchlib)
555 %perl_vendorlib         %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)
556 %perl_vendorarch        %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)
557 %perl_sitelib           %(eval "`%{__perl} -V:installsitelib`"; echo $installsitelib)
558 %perl_sitearch          %(eval "`%{__perl} -V:installsitearch`"; echo $installsitearch)
559
560 # Ruby
561 %ruby_archdir           %(ruby -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)
562 %ruby_ridir                     %(ruby -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)
563 %ruby_rubylibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)
564 %ruby_sitearchdir       %(ruby -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)
565 %ruby_sitelibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)
566 %ruby_version           %(ruby -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)
567 %ruby_ver_requires_eq   Requires:       ruby(ver) = %ruby_version
568 %ruby_mod_ver_requires_eq       Requires:       ruby-modules(ver) = %ruby_version
569
570 %php_pear_dir           /usr/share/pear
571 %php_extensiondir       %(php-config --extension-dir 2>/dev/null || echo ERROR)
572 %php_sysconfdir         %(php-config --sysconfdir 2>/dev/null || echo ERROR)
573
574 # directory where php includes are installed on system.
575 %__php_includedir               /usr/include/php
576 # extract php/zend api versions
577 %php_major_version              %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{__php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)
578 %php_api_version                %(awk '/#define PHP_API_VERSION/{print $3}' %{__php_includedir}/main/php.h 2>/dev/null || echo ERROR)
579 %php_pdo_api_version    %(awk '/#define PDO_DRIVER_API/{print $3}' %{__php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)
580 %php_debug                              %(awk '/#define ZEND_DEBUG/{print $3}' %{__php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)
581 %zend_module_api                %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{__php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)
582 %zend_extension_api             %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{__php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)
583 %zend_zts                               %(Z=$(grep -sc '^#define ZTS 1' %{__php_includedir}/main/php_config.h); echo ${Z:-ERROR})
584
585 # helper macro
586 %__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
587
588 # macros for public use
589 # for php extensions (php-pecl)
590 %requires_php_extension %{__php_api_requires modules_api php_api_version} \
591 %{__php_api_requires zend_module_api} \
592 %{__php_api_requires -v %php_major_version debug php_debug} \
593 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
594
595 # for zend extensions
596 %requires_zend_extension %{__php_api_requires zend_module_api} \
597 %{__php_api_requires zend_extension_api} \
598 %{__php_api_requires -v %php_major_version debug php_debug} \
599 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
600
601 # for php pdo modules (php-pecl-PDO_*)
602 %requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
603
604 # for using PHP post scripts. for PHP >= 5.0
605 %php_webserver_restart \
606 [ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
607 [ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
608 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
609         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
610         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
611                 %service -q php-fcgi restart \
612         fi \
613 fi \
614 %{nil}
615
616 # for using php post scripts. for PHP >= 4.0 && PHP < 5.0
617 %php4_webserver_restart \
618 [ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
619 [ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
620 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
621         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
622         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
623                 %service -q php-fcgi restart \
624         fi \
625 fi \
626 %{nil}
627
628 # Python specific macro definitions.
629 # python main version
630 %py_ver                 %(python -c "import sys; print sys.version[:3]")
631
632 # directories
633 %py_prefix              %(python -c "import sys; print sys.prefix")
634 %py_libdir              %{py_prefix}/%{_lib}/python%{py_ver}
635 %py_scriptdir   %{py_prefix}/share/python%{py_ver}
636 %py_incdir              /usr/include/python%{py_ver}
637 %py_sitedir             %{py_libdir}/site-packages
638 %py_sitescriptdir %{py_scriptdir}/site-packages
639 %py_dyndir              %{py_libdir}/lib-dynload
640
641 # pure python modules compilation
642 %py_comp                python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
643
644 %py_ocomp               python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
645
646 # Software written in Python language require Python with main version
647 %pyrequires_eq() Requires:      %1
648
649 # Hardlink binary identical .pyc and .pyo files
650 # (idea by glen <at> pld-linux <dot> org)
651 %__spec_install_post_py_hardlink {\
652 %{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
653 [ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
654         b="$(echo $a|sed -e 's/.pyc$/.pyo/')"; \
655         if cmp -s "$a" "$b"; then \
656                 ln -f "$a" "$b"; \
657         fi; \
658 done \
659 }; __spec_install_post_py_hardlink } }
660
661 # remove python sources, so that check-files won't complain
662 # (idea by glen <at> pld-linux <dot> org)
663 %py_postclean() \
664 for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
665  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
666 done \
667 %{nil}
668
669 # depmod macro
670 %depmod() { \
671 umask 022; \
672 if [ -e /boot/System.map-%1 ]; then \
673         /sbin/depmod -a -F /boot/System.map-%1 %1; \
674 else \
675         if [ -e /boot/System.map ]; then \
676                 /sbin/depmod -a -F /boot/System.map %1; \
677         else \
678                 /sbin/depmod -a %1; \
679         fi \
680 fi; \
681 }
682
683 # XMMS specific macros
684 %xmms_prefix                    %(xmms-config --prefix 2>/dev/null)
685 %xmms_exec_prefix               %(xmms-config --exec-prefix 2>/dev/null)
686 %xmms_version                   %(xmms-config --version 2>/dev/null)
687 %xmms_datadir                   %(xmms-config --data-dir 2>/dev/null)
688 %xmms_plugindir                 %(xmms-config --plugin-dir 2>/dev/null)
689 %xmms_visualization_plugindir   %(xmms-config --visualization-plugin-dir 2>/dev/null)
690 %xmms_input_plugindir           %(xmms-config --input-plugin-dir 2>/dev/null)
691 %xmms_output_plugindir          %(xmms-config --output-plugin-dir 2>/dev/null)
692 %xmms_effect_plugindir          %(xmms-config --effect-plugin-dir 2>/dev/null)
693 %xmms_general_plugindir         %(xmms-config --general-plugin-dir 2>/dev/null)
694
695 %_target_base_arch      %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')
696
697 # user/group checking macros
698 #
699 # Usage:
700 #       %userremove myuser
701 #
702 %userremove     /usr/lib/rpm/user_group.sh user del
703 %groupremove    /usr/lib/rpm/user_group.sh group del
704 #
705 # Usage:
706 #       if %usertestrm myuser; then
707 #               /usr/sbin/userdel -r myuser
708 # Note:
709 #       use these macros only if you need to call userdel/groupdel with
710 #       a non-standard option or take an extra action; otherwise use the
711 #       %userremove/%groupremove macros
712 #
713 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
714 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
715 # user group membership management macros
716 #
717 # Usage:
718 #       %addusertogroup myuser agroup
719 #
720 %addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
721
722 # banner support (useful in {pre,post}{,un} and triggers)
723 #
724 # Usage:
725 #       %banner name [-a] [-e] [-n] [-tn] <<EOF
726 # the banner text, the banner text
727 # the banner text, and following line
728 #EOF
729 # You can use any form of here-document, <<'EOF' <<-EOT will do.
730 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
731 #
732 # -a   - append to the banner
733 # -e   - send to stderr instead of stdout
734 # -n   - no show banner (overrides -t)
735 # -t   - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
736 %banner(aent:)  \
737 RPM_SCRIPTVERBOSITY=5 \
738 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
739 if [ -x /usr/bin/banner.sh ]; then \
740         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
741 else \
742         CMD="cat%{-e: >&2}" \
743 fi \
744 eval $CMD %2%{?3: %3} \
745 %nil
746
747 # useradd/groupadd macros
748 # Author: Elan Ruusamäe <glen@pld-linux.org>
749 #
750 # Usage:
751 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
752 #   [-g initial_group] [-G group[,...]] login
753 #
754 #  -u uid. REQUIRED
755 #  -g gid/group. REQUIRED
756 #  -s defaults to /bin/false
757 #  -d defaults to /usr/share/empty
758 #  -c No default
759 #  -r is accepted but ignored (it's always set)
760 #  -k skeleton dir. defaults to /usr/share/empty
761 # rpm specific flags
762 #  -P package name. defaults to %{name}
763 #
764 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
765 %{!-u:%{error:useradd: Required argument -u missing}} \
766 %{!-g:%{error:useradd: Required argument -g missing}} \
767 %{!?1:%{error:useradd: Required parameter login missing}} \
768 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
769         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
770                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
771                 exit 1 \
772         fi \
773 else \
774         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
775         /usr/sbin/useradd \\\
776                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
777                 -u %{-u*} \\\
778                 -r \\\
779                 -d %{-d*}%{!-d:/usr/share/empty} \\\
780                 -s %{-s*}%{!-s:/bin/false} \\\
781                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
782                 -g %{-g*} \\\
783                 %{-M} \\\
784                 %{-G:-G %{-G*}} \\\
785                 %{expand:%{%{#}}} 1>&2 || exit $? \
786         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
787 fi;
788
789 # Usage:
790 #   %groupadd [-P package] [-g gid] group
791 #
792 # -g gid. REQUIRED
793 #
794 # Sample:
795 #   %groupadd -P %{name}-base -g %{gid} %{name}
796
797 %groupadd(g:P:rfo)      \
798 %{!-g:%{error:groupadd: Required argument -g missing}} \
799 %{!?1:%{error:groupadd: Required parameter group missing}} \
800 if [ -n "`/usr/bin/getgid %{1}`" ]; then \
801         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
802                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
803                 exit 1 \
804         fi \
805 else \
806         echo "Adding group %{1} GID=%{-g*}." \
807         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
808         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
809 fi;
810
811 # apache_config_{install/uninstall} macros *DEPRECATED*
812 # Author: Elan Ruusamäe <glen@pld-linux.org>
813 #
814 # You should use webapp macros instead. these are here until single piece of
815 # them is gone from specs ;)
816 #
817 # The config is installed/removed inside trigger, this means that you can any
818 # time install apache1 or apache package and the configuration file is updated.
819 # if you don't need the config for various reason for specific apache, just
820 # remove the symlink from apache config directory. the trigger will not put the
821 # config again to that version of apache. In other words the config is linked
822 # to apache config directory on first install of PACKAGE or apache.
823 #
824 # should be called in trigger body:
825 #  %triggerin -- apache1 >= 1.3.33-2
826 #  %apache_config_install -v 1
827 #
828 # Add package's apache config to apache config.
829 #
830 # Usage:
831 #   %apache_config_install -v {1|2} -c %{_sysconfdir}/apache-%{name}.conf -n 99
832 #
833 #  -v REQUIRED: specify apache version. can be 1 or 2.
834 #  -c OPTIONAL: specify full path to PACKAGE's config. Defaults to %{_sysconfdir}/apache-%{name}.conf.
835 #  -n OPTIONAL: specify config "slot". defaults to 99
836 #  -f OPTIONAL: force symlink creation regardless if package was upraded. useful in triggers
837 #
838 # Internal macros. don't use ;).
839 # expands apache config dir by apache version at build time.
840 %__apache_confdir() %(if [ %{1} = 1 ]; then echo /etc/apache/conf.d; elif [ %{1} = 2 ]; then echo /etc/httpd/httpd.conf; else echo >&2 Unknown apache version specified; fi)
841 # expands apache service name by apache version at build time.
842 %__apache_svcname() %(if [ %{1} = 1 ]; then echo apache; elif [ %{1} = 2 ]; then echo httpd; else echo >&2 Unknown apache version specified; fi)
843
844 %apache_config_install(fv:c:n:) \
845 %{!-v:%{error:apache_config_install: Required argument -v missing}} \
846 %{?debug:set -x; echo "apache_config_install:%{-v*} %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
847 if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ]) && [ -d %{__apache_confdir %{-v*}} ]; then\
848         ln -sf %{-c*}%{!-c:%{_sysconfdir}/apache-%{name}.conf} %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf\
849 fi\
850 # reload apache if the config symlink is there\
851 if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then\
852         # additionally don't reload if target package (the webserver) is upgraded, as webserver is restarted anyway in %post \
853         if [ "$2" != "2" ] && [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then\
854                 /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2\
855         fi\
856 fi\
857 %{nil}
858
859 # Remove package's apache config from apache config.
860 #
861 # Usage:
862 #   %apache_config_uninstall -v {1|2} -n 99
863 #
864 #  -v REQUIRED: specify apache version. can be 1 or 2.
865 #  -n OPTIONAL: specify config "slot". defaults to 99
866 %apache_config_uninstall(v:n:) \
867 %{!-v:%{error:apache_config_uninstall: Required argument -v missing}} \
868 %{?debug:set -x; echo "apache_config_uninstall:%{-v*} %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
869 # remove link if either of the packages are gone \
870 if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
871         if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then \
872                 rm -f %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf \
873                 if [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then \
874                         /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2 \
875                 fi \
876         fi \
877 fi \
878 %{nil}
879
880 # webapp macros
881 # Author: Elan Ruusamäe <glen@pld-linux.org>
882 #
883 # The config is installed/removed inside trigger, this means that you can any
884 # time install apache1/apache/lighttpd package and the configuration file is
885 # updated. if you don't need the config for various reason for specific
886 # webserver, just remove the symlink from config directory using webapp
887 # program. the trigger will not recreate the symlink on upgrades. In other
888 # words the config is linked to webserver config directory on first install of
889 # PACKAGE or WEBSERVER.
890 #
891 # Add package's webserver config to webserver webapps dir.
892 # Usage:
893 #   %webapp_register WEBSERVER WEBAPP
894 #
895 %webapp_register() \
896 %{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
897 if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
898         /usr/sbin/webapp register %1 %2\
899 fi\
900 # reload webserver if the config symlink is there and skip reload if webserver is upgraded\
901 if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
902         %{expand:%service -q %%1 reload}\
903 fi\
904 %{nil}
905
906 # Remove package's config from webserver webapps dir.
907 # Usage:
908 #   %webapp_register [-f] WEBSERVER WEBAPP
909 %webapp_unregister(f) \
910 %{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
911 # remove link if either of the packages are gone \
912 if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
913         /usr/sbin/webapp unregister %1 %2\
914         %{expand:%service -q %%1 reload}\
915 fi \
916 %{nil}
917
918 # see browser-plugins.spec / template-browser-plugin.spec
919 # Author: Elan Ruusamäe <glen@pld-linux.org>
920 %nsplugin_install(d:f) { \
921 # create link if it's first install of either of the packages \
922 if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ] && [ -d %{-d*} ]); then \
923 ( \
924 %( \
925         for file in %{*}; do \
926                 echo echo Installing $file to %{-d*}; \
927                 echo "ln -sf %{_libdir}/browser-plugins/$file %{-d*};"; \
928         done ) \
929 ) | ( %banner -t 5 -e %{name}-in ); fi; \
930 }
931
932 %nsplugin_uninstall(d:) { \
933 # remove link if either of the packages are gone \
934 if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
935 ( \
936 %( \
937         for file in %{*}; do \
938                 echo echo Removing $file from %{-d*}; \
939                 echo "rm -f %{-d*}/$file;"; \
940         done ) \
941 ) | ( %banner -t 5 -e %{name}-un ); fi; \
942 }
943
944 # service macro.
945 # Author: Elan Ruusamäe <glen@pld-linux.org>
946 #
947 # calls usual service restart on package %post, but skips the restart if
948 # administrator has disabled automatic service restarts in either global
949 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
950 #
951 # Usage:
952 #   %service [-q] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
953 #
954 #  -q be silent when service isn't started (for scriplets restaring other package's services)
955 #
956 %service(q) {{%(export quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
957
958
959 # Java macros. based on jpackage macros.java
960 #
961 # Root directory where all Java VMs/SDK/JREs are installed.
962 %_jvmdir                %{_libdir}/jvm
963
964 # Root directory where all Java VMs/SDK/JREs expose their jars
965 %_jvmjardir             %{_libdir}/jvm-exports
966
967 # Root directory for all Java VM/SDK/JRE's private things.
968 %_jvmprivdir    %{_libdir}/jvm-private
969
970 # Root directory for all architecture dependent parts of Java VM/SDK/JRE's
971 %_jvmlibdir             %{_libdir}/jvm
972
973 # Root directory for all architecture independent parts of Java VM/SDK/JRE's
974 %_jvmdatadir    %{_datadir}/jvm
975
976 # Root directory for all configurations parts of Java VM/SDK/JRE's
977 %_jvmsysconfdir %{_sysconfdir}/jvm
978
979 # Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
980 %_jvmcommonlibdir       %{_libdir}/jvm-common
981
982 # Root directory for all common architecture independent parts of Java VM/SDK/JRE's
983 %_jvmcommondatadir      %{_datadir}/jvm-common
984
985 # Root directory for all common configurations parts of Java VM/SDK/JRE's
986 %_jvmcommonsysconfdir   %{_sysconfdir}/jvm-common
987
988 # Directory where arch-specific (JNI) version-independent jars are installed.
989 %_jnidir                %{_libdir}/java
990
991
992 %java_home              %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})
993
994 %ant                    JAVA_HOME=%{java_home} ant
995 %jar                    %{java_home}/bin/jar
996 %java                   %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)
997 %javac                  %{java_home}/bin/javac
998 %javadoc                %{java_home}/bin/javadoc
999
1000 %add_jvm_extension      JAVA_LIBDIR=%{buildroot}/%{_javadir}    %{_bindir}/jvmjar -l
1001
1002 %jpackage_script() \
1003 install -d $RPM_BUILD_ROOT%{_bindir}\
1004 cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
1005 #!/bin/sh\
1006 #\
1007 # %{name} script\
1008 # JPackage Project <http://www.jpackage.org/>\
1009 \
1010 # Source functions library\
1011 . %{_javadir}-utils/java-functions\
1012 \
1013 # Source system prefs\
1014 if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1015     . %{_sysconfdir}/java/%{name}.conf\
1016 fi\
1017 \
1018 # Source user prefs\
1019 if [ -f $HOME/.%{name}rc ]; then\
1020     . $HOME/.%{name}rc\
1021 fi\
1022 \
1023 # Configuration\
1024 MAIN_CLASS=%1\
1025 BASE_FLAGS=%2\
1026 BASE_OPTIONS=%3\
1027 BASE_JARS="%(echo %4 | tr ':' ' ')"\
1028 \
1029 # Set parameters\
1030 set_jvm\
1031 set_classpath $BASE_JARS\
1032 set_flags $BASE_FLAGS\
1033 set_options $BASE_OPTIONS\
1034 \
1035 # Let's start\
1036 run "$@"\
1037 EOF
1038
1039 # PEAR install macros
1040 # Author: Elan Ruusamäe <glen@pld-linux.org>
1041 #
1042 # Usage:
1043 #       %%pear_package_setup [-a #] [-n FMT]
1044 #
1045 # -a #   - also unpack SOURCE#. for PEAR bootstrapping
1046 # -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1047 # -z     - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1048 #
1049 # unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1050 # destination hierarchy. you should copy the tree to buildroot after
1051 # patching/reorganizing with %%pear_package_install.
1052 #
1053 # additionally BUILDROOT is stripped from files and files are converted to UNIX
1054 # line endings.
1055 #
1056 # the pear install process output is recorded to install.log, you should put it
1057 # to %%doc for later debug or just for information.
1058 #
1059 # additionally additional-packages.txt is produced if it was detected that the
1060 # package has optional dependencies. the file format is suitable of displaying
1061 # in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1062 # automatically added for this file.
1063
1064
1065 # records install.log and transforms PEAR names to PLD Linux rpm package names.
1066 %__pear_install_log \
1067 tee install.log \
1068 # make post message of optional packages \
1069 grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
1070 if [ -s optional-packages.txt ]; then \
1071         awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1072 else \
1073         rm -f optional-packages.txt \
1074 fi \
1075 %{nil}
1076
1077 # command invoking pear cli
1078 %__pear /usr/bin/pear
1079
1080 # The main macro.
1081 # using this macro will append optional-packages.txt to the nocompressdoc list
1082 # as it's displayed to user after package install. and adding additional gzip
1083 # dep is just waste ;)
1084 %pear_package_setup(a:n:zD) \
1085 %define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1086 %define builddir %{_builddir}/%{srcdir} \
1087 %setup -q -c -T %{-D:-D} -n %{srcdir} \
1088 %{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1089 %{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1090 %__pear \\\
1091         -c pearrc \\\
1092         -d doc_dir=/docs \\\
1093         -d php_dir=%{php_pear_dir} \\\
1094         -d bin_dir=%{_bindir} \\\
1095         -d data_dir=%{php_pear_dir}/data \\\
1096         -d test_dir=%{php_pear_dir}/tests \\\
1097         install \\\
1098         --packagingroot=%{builddir} \\\
1099         --offline \\\
1100         --nodeps \\\
1101         %{-f:--force} \\\
1102         %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; } \
1103 %{-z:cd ..} \
1104 cat %{-z:$_N/}.install.log | %__pear_install_log \
1105 \
1106 # undos sources \
1107 find . -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1108 %{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1109 %{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1110 %{nil}
1111
1112 # Copies exctracted PEAR package structure and PEAR registry to buildroot.
1113 # Author: Elan Ruusamäe <glen@pld-linux.org>
1114 %pear_package_install() \
1115 cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1116 find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1117 # help the developer out a little: \
1118 if [ -f _noautoreq ]; then \
1119         echo "AutoReqdep detected:" \
1120         echo "_noautoreq $(cat _noautoreq)" \
1121 fi \
1122 %{nil}
1123
1124
1125 # Register OpenLDAP schema.
1126 # Author: Elan Ruusamäe <glen@pld-linux.org>
1127 #
1128 # Usage:
1129 #   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1130 #
1131 #  -d specify dependant schemas, separated by comma
1132 #
1133 %openldap_schema_register(d:) \
1134 for schema in %*; do \
1135         if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1136                 %{__sed} -i -e " \
1137                         /^include.*local.schema/{ \
1138                                 iinclude\\t     $schema\
1139                         } \
1140                 " /etc/openldap/slapd.conf \
1141         fi \
1142 done \
1143 # enable dependant schemas \
1144 if [ "%{-d*}" ]; then \
1145         %{__sed} -i -e ' \
1146         /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1147                 s/^#// \
1148         }' /etc/openldap/slapd.conf \
1149 fi \
1150 %{nil}
1151
1152 # Unregister OpenLDAP schema.
1153 # Author: Elan Ruusamäe <glen@pld-linux.org>
1154 #
1155 # Usage:
1156 #   %%openldap_schema_unregister %{schemadir}/horde.schema
1157 #
1158 %openldap_schema_unregister() \
1159 for schema in %*; do \
1160         if grep -q "$schema" /etc/openldap/slapd.conf; then \
1161                 %{__sed} -i -e " \
1162                 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1163                 # for symmetry it would be nice if we disable enabled schemas in post, \
1164                 # but we really can not do that, it would break something else. \
1165                 " /etc/openldap/slapd.conf \
1166         fi \
1167 done \
1168 %{nil}
1169
1170 %env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1171
1172
1173 # Build modules for kernels 2.6
1174 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1175 #
1176 # Usage:
1177 #       %build_kernel_modules -m <modules> -C <directory>
1178 #
1179 #  remember that proper Makefile is still required
1180 # Options:
1181 #  -m <modules> (required) -- comma-separated list of modules to save,
1182 #               without .ko extension, may be placed in subdirectory
1183 #  -C <directory> -- change to <directory> before doing anything
1184 #  -p <arg>, -P <arg> -- arguments passeed to make scripts
1185 #  -c -- do not execute make clean
1186 #  <additional arguments> -- all additional arguments will be passed to
1187 #               make modules
1188 #
1189 # Additional patching supported via here document. Try:
1190 #       %build_kernel_modules -m module <<'EOF'
1191 #       your patch script here
1192 #       EOF
1193 # Don't use it unless patching depends on config options.
1194
1195 # Developer note: don't touch it unless you know how to handle '\'.
1196 # - \ in script expands to nothing
1197 # - \\\ in script expands to \
1198 # - \\\ inside definition expands to nothing
1199 # - \\\\\\\ inside definition expands to \
1200 # - in last line \ has to touch arguments so arguments passing
1201 #   in new lines (using \) will be supported
1202
1203 %build_kernel_modules(p:P:m:C:c)                                                                        \
1204 %{!?-m:%{error:%{0}: Required module name/list missing} exit 1}         \
1205                                                                                                                                         \
1206 %define Opts                                                                                                            \\\\\\\
1207 %if "%{_target_base_arch}" != "%{_arch}"                                                        \\\
1208         %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"  \\\
1209         CC="%{__cc}" CPP="%{__cpp}" ARCH=%{_target_base_arch}                   \\\
1210         %else                                                                                                                   \\\
1211         ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1212         %endif                                                                                                                  \\\
1213 %else                                                                                                                           \\\
1214         CC="%{__cc}" CPP="%{__cpp}"                                                                             \\\
1215 %endif                                                                                                                          \
1216 %define MakeOpts HOSTCC="%{__cc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1217                 O=$PWD/o %{?with_verbose:V=1} %{Opts}                                           \
1218                                                                                                                                         \
1219 %{?-C:cd %{-C*}}                                                                                                        \
1220 compile() {                                                                                                                     \
1221         L="<"; [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)"    \
1222         set -e -x                                                                                                               \
1223                                                                                                                                         \
1224 for cfg in %{?with_dist_kernel:dist}%{!?with_dist_kernel:nondist}; do \
1225         [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1                                 \
1226                                                                                                                                         \
1227         rm -rf o                                                                                                                \
1228         install -d o/include/linux                                                                              \
1229         ln -sf %{_kernelsrcdir}/config-$cfg o/.config                                   \
1230         ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers    \
1231         ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1232 %ifarch ppc ppc64                                                                                                       \
1233         install -d o/include/asm                                                                                \
1234         [ ! -d %{_kernelsrcdir}/include/asm-%{_target_base_arch} ] || ln -sf %{_kernelsrcdir}/include/asm-%{_target_base_arch}/* o/include/asm \
1235         [ ! -d %{_kernelsrcdir}/include/asm-powerpc ] || ln -snf %{_kernelsrcdir}/include/asm-powerpc/* o/include/asm   \
1236 %else                                                                                                                           \
1237         ln -sf %{_kernelsrcdir}/include/asm-%{_target_base_arch} o/include/asm \
1238 %endif                                                                                                                          \
1239                                                                                                                                         \
1240         set +x                                                                                                                  \
1241         [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell    \
1242         set -x                                                                                                                  \
1243                                                                                                                                         \
1244         %if %{with dist_kernel}                                                                                 \
1245                 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts                       \\\
1246                         %{-p*} %{-P*}                                                                                   \\\
1247                         %{MakeOpts}                                                                                             \
1248         %else                                                                                                                   \
1249                 install -d o/include/config                                                                     \
1250                 touch o/include/config/MARKER                                                           \
1251                 ln -sf %{_kernelsrcdir}/scripts o/scripts                                       \
1252         %endif                                                                                                                  \
1253                                                                                                                                         \
1254         %{!?-c:%{__make} -C %{_kernelsrcdir} clean                                              \\\
1255                 RCS_FIND_IGNORE="-name '*.ko' -o"                                                       \\\
1256                 M=$PWD %{MakeOpts}}                                                                                     \
1257         %{__make} -C %{_kernelsrcdir} modules                                                   \\\
1258                 ${1+"$@"}                                                                                                       \\\
1259                 M=$PWD %{MakeOpts}                                                                                      \
1260                                                                                                                                         \
1261         for MODULE in {%{-m*},}; do                                                                             \
1262                 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko                           \
1263         done                                                                                                                    \
1264 done                                                                                                                            \
1265 %{?-C:cd -}                                                                                                                     \
1266 }                                                                                                                                       \
1267 compile %{*}\
1268 %{nil}
1269
1270
1271 # Install kernel modules built by %build_kernel_modules
1272 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1273 #
1274 # Usage:
1275 #       %install_kernel_modules -m <modules> -d <directory>
1276 #
1277 # Options:
1278 #  -m <modules> (required) -- comma-separated list of modules to install,
1279 #               without .ko extension, may be placed in subdirectory
1280 #  -d <directory> (required) -- in what subdirectory modules should be
1281 #               installed (eg. misc, kernel/drivers/net)
1282 #  -s <suffix> -- suffix to use when installing modules, useful when module
1283 #               with same name exists in kernel already
1284 #  -n <file> -- name of modprobe config file to use (without .conf extension)
1285 #               for definig aliases, only useful with -s
1286
1287 %install_kernel_modules(m:d:s:n:)                                                                       \
1288 %{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1}          \
1289 %{!?-d:%{error:%{0}: Required module directory missing}exit 1}          \
1290 %{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1291                                                                                                                                         \
1292 %define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}                      \
1293 %define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1294                                                                                                                                         \
1295 install -d %{KernelD}/%{-d*}                                                                    \
1296 %{?-s:install -d %{ModprobeD}}                                                          \
1297                                                                                                                                         \
1298 for MODULE in {%{-m*},}; do                                                                                     \
1299         [ -n "${MODULE}" ] || continue                                                                  \
1300         MNAME=${MODULE##*/}                                                                                             \
1301         %if %{without dist_kernel}                                                                              \
1302                 install ${MODULE}-nondist.ko                                                            \\\
1303                         %{KernelD}/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                              \
1304                 %{?-s:echo "alias ${MNAME} ${MNAME}-%{-s*}"                                     \\\
1305                         >> %{ModprobeD}/%{-n*}.conf}                                                    \
1306         %else                                                                                                                   \
1307                 install ${MODULE}-dist.ko                                                                               \\\
1308                         %{KernelD}/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                              \
1309                 %{?-s:echo "alias ${MNAME} ${MNAME}-%{-s*}"                                     \\\
1310                         >> %{ModprobeD}/%{-n*}.conf}                                                    \
1311         %endif                                                                                                                  \
1312 done                                                                                                                            \
1313 %{nil}
1314
1315 # patchset macros
1316 # Author: Elan Ruusamäe <glen@pld-linux.org>
1317 #
1318 # Usage:
1319 #   %patchset_source -f <seq(1) format> <start> [<end>]
1320 #   %patchset_patch <start> [<end>]
1321 #
1322 # If <end> is omited, it is assumed to be <start>.
1323 #
1324 # For example in preamble:
1325 #  %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1326 # and in %prep:
1327 #  %patchset_patch 33 44
1328
1329 # generate SourceX urls from range START STOP
1330 # Format can be SINGLE format char of %e, %f, %g, see seq(1)
1331 # The sources start from 10000
1332 %patchset_source(f:b:) %(
1333         base=%{-b*}%{!-b*:10000};
1334         start=$(expr $base + %1);
1335         end=$(expr $base + %{?2}%{!?2:%{1}});
1336         # we need to call seq twice as it doesn't allow two formats
1337         seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1338         seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1339         paste %{tmpdir}/__ps{1,2};
1340         rm -f %{tmpdir}/__ps{1,2};
1341 ) \
1342 %{nil}
1343
1344 # apply sources from %patchset_source
1345 # -p specify -pX for %patch line
1346 # -b base offset: defaults to 10000
1347 %patchset_patch(f:p:b:) %(
1348         base=%{-b*}%{!-b*:10000};
1349         start=$(expr $base + %1);
1350         end=$(expr $base + %{?2}%{!?2:%{1}});
1351         echo ": patchset_patch %1%{?2: to %2}";
1352         seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1353 ) \
1354 %{nil}
1355
1356 # browser plugins v2
1357 # Author: Elan Ruusamäe <glen@pld-linux.org>
1358 #
1359 # Usage:
1360 #       %browser_plugins_add_browser <name> -p <plugindir>
1361 #
1362 #  <name> (required) -- name of the browser. usually %{name}.
1363 #  -p <plugindir> (required) -- in what directory browser searches for its plugins.
1364 #  -b -- default blacklists
1365 #  -a <arch> override arch
1366 #
1367 # Example:
1368 #   %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1369
1370 %_browserpluginsconfdir         /etc/browser-plugins
1371 %_browserpluginsdir                     %{_libdir}/browser-plugins
1372 %update_browser_plugins         /usr/sbin/update-browser-plugins || :
1373
1374 %browser_plugins_add_browser(p:b:a:) \
1375         browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1376         install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1377         ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1378         blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1379         echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1380         %{-b:cat >> $blacklist_file %{-b*}} \
1381 %{nil}
1382
1383 # vim:ts=4 sw=4 noet syn=spec
This page took 0.237415 seconds and 3 git commands to generate.